#ifndef DSP_H
#define DSP_H

/* Create and return a descriptor for use with the dot product function */
void *initdp(signed short coeffs[],int len);

/* Free a dot product descriptor created earlier */
void freedp(void *dp);

/* Compute a dot product given a descriptor and an input array
 * The length is taken from the descriptor
 */
long dotprod(void *dp,signed short a[]);

/* Sum of squares - accepts signed shorts, produces unsigned long long */
unsigned long long sumsq_wq(signed short *in,int cnt);

/* Sum of squares - accepts signed shorts, produces unsigned long
 * Fast but prone to overflow -- use only on small values & short arrays
 */
unsigned long sumsq_wd(signed short *in,int cnt);

#endif
