#if defined(SSE2)

int peakval_sse2(signed short *,int);

int peakval(signed short *b,int cnt){
  int peak = 0;
  int a;

  while(((int)b & 15) != 0 && cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  a = peakval_sse2(b,cnt);
  if(a > peak)
    peak = a;
  b += cnt & ~7;
  cnt &= 7;

  while(cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  return peak;
}  

#elif defined(SSE)

int peakval_sse(signed short *,int);

int peakval(signed short *b,int cnt){
  int peak = 0;
  int a;

  while(((int)b & 7) != 0 && cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  a = peakval_sse(b,cnt);
  if(a > peak)
    peak = a;
  b += cnt & ~3;
  cnt &= 3;

  while(cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  return peak;
}  

#elif defined(MMX)

int peakval_mmx(signed short *,int);

int peakval(signed short *b,int cnt){
  int peak = 0;
  int a;

  while(((int)b & 7) != 0 && cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  a = peakval_mmx(b,cnt);
  if(a > peak)
    peak = a;
  b += cnt & ~3;
  cnt &= 3;

  while(cnt != 0){
    a = abs(*b);
    if(a > peak)
      peak = a;
    b++;
    cnt--;
  }
  return peak;
}  


#else
int peakval(signed short *b,int len){
  int peak = 0;
  int a,i;

  for(i=0;i<len;i++){
    a = abs(b[i]);
    if(a > peak)
      peak = a;
  }
  return peak;
}
#endif
